#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <string>

#include <libdbox.h>
#include <mtoolerfc.h>
#include <stringtools.h>

void erfcmessaget::copyheaderid(char *dest, const char *id,
                                size_t maxlen) const
 {
  while(maxlen!=0 && *id!=0 && *id!=':' && id<endoffile)
   {
    *dest=*id;
    dest++;
    id++;
    maxlen--;
   }

  *dest=0;
 }

void erfcmessaget::copyheaderid(string &dest, const char *id) const
 {
  dest="";
  while(*id!=0 && *id!=':' && id<endoffile)
    dest+=*(id++);
 }

void erfcmessaget::copyheadertext(char *dest, const char *text,
                                  size_t maxlen) const
 {
  bool end=FALSE;

  while(maxlen!=0 && *text!=0 && text<endoffile && !end)
   {
    if(*text=='\n')
      end=TRUE;
    else if(*text=='\r')
     {
      if((text+1)==endoffile || text[1]!='\n')
        end=TRUE;
     }
    else if(maxlen!=0)
     {
      *(dest++)=*text;
      maxlen--;
     }

    text++;
   }

  *dest=0;
 }

void erfcmessaget::copyheadertext(string &dest, const char *text) const
 {
  dest="";

  bool end=FALSE;

  while(*text!=0 && text<endoffile && !end)
   {
    if(*text=='\n')
      end=TRUE;
    else if(*text=='\r')
     {
      if((text+1)==endoffile || text[1]!='\n')
        end=TRUE;
     }
    else
      dest+=(*text);

    text++;
   }
 }

bool erfcmessaget::parseline(const char **start, 
                             const char **id, 
                             const char **text) const
 {
  const char *d=*start;
  if(*d=='\r' || *d=='\n')
   {
    *id=*text=(char *)NULL;
    if(*d=='\r' && d<endoffile) d++;
    if(*d=='\n' && d<endoffile) d++;
    *start=d;
    return FALSE;
   }

  *id=d;

  if(d==endoffile) return TRUE;

  while(*d!=':')
   {
    if(d==endoffile || *d==0) return TRUE;
    d++;
   }

  d++; // skip :

  while(*d==' ' || *d=='\t') // skip spaces
   {
    if(d==endoffile) return TRUE;
    d++;
   }

  *text=d;

  while(TRUE)
   {
    if(d==endoffile || *d==0) return TRUE;

    if(*d=='\r')
     {
      if((d+1)==endoffile)
       {
        d++;
        break;
       }
      else if(d[1]!='\n')
        return TRUE;
      else // "\r\n"
       {
        d++;
        d++;        
        break;
       }
     }
    else if(*d=='\n')
     {
      d++;
      break;
     }

    d++;
   }

  *start=d;

  return FALSE;
 }

bool erfcmessaget::parse()
 {
  const char *d=data, *id, *text;

  len=0xffffffff;

  while(TRUE)
   {
    if(parseline(&d, &id, &text)) return TRUE;

    if(id==NULL)
     {
      if(len==0xffffffff) return TRUE;
      headerlen=d-data;
      endofmail=d+len;
      if(endofmail>endoffile) return TRUE;
      return FALSE;
     }
    else 
     {
      char tempstr[200];
      copyheaderid(tempstr, id, 199);

      if(stricmp(tempstr, "LEN")==0)
        len=atol(text);
     }
   }
 }

bool erfcmessaget::copyheader_special(FILE *outfile, byte *RCPTs) const
 {
  const char *d=data, *id, *text;
  dword RCPTnr=0;
  char tempstr[200];

  while(TRUE)
   {
    if(parseline(&d, &id, &text)) return TRUE;
    if(id==NULL)
     {
      fprintf(outfile, "\r\n");
      return FALSE;
     }

    copyheaderid(tempstr, id, 199);
    if(stricmp(tempstr, "RCPT")==0)
     {
      switch(RCPTs[RCPTnr++])
       {
       case 0:
        goto docopy;

       case 1: // KOP
        break;

       case 2: // DROP
        break;
       }
     }
    else
     {
     docopy:
      fwrite(id, 1, d-id, outfile);
     }
   }
 }


