/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: show web quotas

*/

#include <userdb.h>
#include "www_quota.h"
#include "../webonline/formsize.h"

void show_webquota(userpt &up)
 {
  long files, size;

  get_www_quota_usage(up, files, size);

  cout.form("%-30s ", (string(up.name)+":").c_str());
  cout.form("%8ld files, ", files);
  cout.form("%15s\n", formsize(size).c_str());
 }

void list_webquota()
 {
  userpt up;
  char username[TEXTLEN];
  char *tptr;

  while(fgets(username, TEXTLEN-1, stdin)!=NULL)
    if(username[0]!=0 && username[0]!='.' && username[0]!='_')
     {
      tptr=strchr(username, '\r'); if(tptr!=NULL) *tptr=0;
      tptr=strchr(username, '\n'); if(tptr!=NULL) *tptr=0;

      username[TEXTLEN-1]=0;
      tptr=strrchr(username, '/');
      if(tptr!=NULL) *tptr=0;
      strcpy(up.name, username);
      if(up.read())
        fprintf(stderr, "Not found: %s\n", username);
      else if((up|"alias")[0]==0)
        show_webquota(up);
     }
 }


